package com.chinaitop.depot.basic.service;

import com.chinaitop.depot.basic.model.MonitorNvr;
import com.chinaitop.depot.basic.model.MonitorNvrExample;

import java.util.List;
import java.util.Map;

public interface MonitorNvrService {

    /**
     * 条件查询nvr列表
     * @param example
     * @return
     */
    List<MonitorNvr> selectByExample(MonitorNvrExample example);

    /**
     * 新增nvr信息
     * @param monitorNvr
     */
    void save(MonitorNvr monitorNvr);

    /**
     * 根据nvr主键id删除数据
     * @param id
     */
    void remove(int id);

    /**
     * 根据id查询数据
     * @param id
     * @return
     */
    MonitorNvr loadDataById(int id);

    /**
     * 根据nvrid获取camera通道号信息列表
     * @param nvrId
     * @return
     */
    List<Map<String,Object>> getThroughByNVRId(Integer nvrId);

    /**
     * 新增通道号信息
     * @param nvrId
     * @return
     */
    void addChannelNumber(List<Map<String, Object>> channel, String nvrId);


    /**
     * 导入
     * @param list
     * @return 
     */
    String importData(List<List<String>> list,Integer orgid);

}
