package com.chinaitop.depot.basic.service.impl;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import com.chinaitop.depot.basic.mapper.CameraStorehouseMapper;
import com.chinaitop.depot.basic.mapper.MonitorNvrMapper;
import com.chinaitop.depot.basic.model.CameraStorehouse;
import com.chinaitop.depot.basic.model.MonitorNvr;
import com.chinaitop.depot.utils.ParameterUtil;
import org.springframework.stereotype.Service;

import com.chinaitop.depot.basic.mapper.MonitorCameraMapper;
import com.chinaitop.depot.basic.model.MonitorCamera;
import com.chinaitop.depot.basic.model.MonitorCameraExample;
import com.chinaitop.depot.basic.service.MonitorCameraService;

@Service
public class MonitorCameraServiceImpl implements MonitorCameraService {

    @Resource
    private MonitorCameraMapper cameraMapper;

	@Resource
	private MonitorNvrMapper nvrMapper;

	@Resource
	private CameraStorehouseMapper cameraStorehouseMapper;

	@Override
    public List<MonitorCamera> queryByExample(MonitorCameraExample example) {
        return cameraMapper.selectByExample(example);
    }

    @Override
    public MonitorCamera findById(Integer id) {
        return cameraMapper.selectById(id);
    }

    @Override
    public void add(MonitorCamera camera) {
        cameraMapper.insert(camera);
    }

    @Override
    public void update(MonitorCamera camera) {
        cameraMapper.updateByPrimaryKey(camera);
    }

    @Override
    public void updateDeleteById(Integer id) {
        MonitorCamera camera = new MonitorCamera();
        camera.setIsremove("0");//默认设置删除标志
        MonitorCameraExample example = new MonitorCameraExample();
        MonitorCameraExample.Criteria criteria = example.createCriteria();
        criteria.andIdEqualTo(id);
        cameraMapper.updateByExampleSelective(camera,example);
    }

    @Override
    public List<Map<String,Object>> selectByNVRDates(Map<String,Object> map) {
        return cameraMapper.selectByNVRDates(map);
    }

	@Override
	public List<Map<String,Object>> getAgentDepot(Map<String,Object> map) {
		return cameraMapper.getAgentDepot(map);
	}

    @Override
    public List<Map<String,Object>> getAgentVideo(Map<String,Object> map) {
        return cameraMapper.getAgentVideo(map);
    }

	@Override
	public String importData(List<List<String>> list, Integer orgId) {
		Date date = new Date();
		MonitorCamera camera = null;
		CameraStorehouse cameraStorehouse = null;
//		Integer index = null;
//		String value = null;
		
		String msg = "";
		Map<String,Object> enumData = new HashMap<>();
        boolean value_flag = false;
    	int len = 0;
    	String ip = "([1-9]|[1-9]\\d|1\\d{2}|2[0-4]\\d|25[0-5])(\\.(\\d|[1-9]\\d|1\\d{2}|2[0-4]\\d|25[0-5])){3}";
		MonitorNvr nvrDate = new MonitorNvr();
		String tdh = null;

		for (int i = 0; i < list.size(); i++) {
            List<String> revList = list.get(i);
            
            for (int j = 0; j < revList.size(); j++) {
            	switch(j) {
            		case 0:
        				camera = new MonitorCamera();
        				if (revList.get(j) != null && !"".equals(revList.get(j))) {
        					len = revList.get(j).length();
                    		if (len > 30) {
                    			msg = "第 "+(i+1)+" 行第 1 列的值的长度不能超过30！";
                    			return msg;
                    		}
        					camera.setName(revList.get(j));
        				}
        				camera.setIsremove("1");//默认设置删除标志
        				camera.setUpdateTime(date);//修改时间
        				camera.setOrgId(orgId.toString());
                		break;
            		case 1:
            			if (revList.get(j) != null && !"".equals(revList.get(j))) {
            				len = revList.get(j).length();
                    		if (len > 30) {
                    			msg = "第 "+(i+1)+" 行第 2 列的值的长度不能超过30！";
                    			return msg;
                    		}
            			}
            			camera.setAlias(revList.get(j));
            			break;
            		case 2:
            			//厂商
            			if (revList.get(j) != null && !"".equals(revList.get(j))) {
            				if (!"200".equals(revList.get(j)) && !"300".equals(revList.get(j))) {
            					msg = "第 "+(i+1)+" 行第 3 列的值必须是200或者300！";
            					return msg;
            				}
            			}
//			            index = revList.get(j).indexOf("-");
//			            value = revList.get(j).substring(0, index);
			            camera.setFactory(revList.get(j));
            			break;
            		case 3:
            			len = revList.get(j).length();
                		if (len > 20) {
                			msg = "第 "+(i+1)+" 行第 4 列的值的长度不能超过20！";
                			return msg;
                		}
            			camera.setUsername(revList.get(j));
            			break;
            		case 4:
            			len = revList.get(j).length();
                		if (len > 20) {
                			msg = "第 "+(i+1)+" 行第 5 列的值的长度不能超过20！";
                			return msg;
                		}
            			camera.setPassword(revList.get(j));
            			break;
					case 5:
						if(i == 0){
							nvrDate = nvrMapper.selectByPrimaryKey(Integer.parseInt(revList.get(j)));
						}else if(revList.get(j) != revList.get(j-1)){
							nvrDate = nvrMapper.selectByPrimaryKey(Integer.parseInt(revList.get(j)));
						}
						if(ParameterUtil.isnull(nvrDate)){
							msg = "第 "+(i+1)+" 行第 6 列的硬盘录像机编号数据库中没有，请先添加硬盘录像机！";
							return msg;
						}
						camera.setNvrId(revList.get(j));
						break;
					case 6:
						len = revList.get(j).length();
						if (len > 20) {
							msg = "第 "+(i+1)+" 行第 7 列的值的长度不能超过20！";
							return msg;
						}
						tdh = ParameterUtil.isequal(nvrDate.getFactory(),"200")?String.valueOf(Integer.parseInt(revList.get(j))+32):String.valueOf(Integer.valueOf(revList.get(j)));
						camera.setChannelNumber(tdh);
						break;
            		case 7:
            			//IP地址
            			value_flag = revList.get(j).matches(ip);
                		if (!value_flag) {
                			msg = "第 "+(i+1)+" 行的第 8 列的值不符合IP规范！";
                			return msg;
                		}
            			camera.setIp(revList.get(j));
            			break;
            		case 8:
            			//子网掩码
            			if (revList.get(j) != null && !"".equals(revList.get(j))) {
            				value_flag = revList.get(j).matches(ip);
            				if (!value_flag) {
                    			msg = "第 "+(i+1)+" 行的第 9 列的值不符合IP规范！";
                    			return msg;
                    		}
            			}
            			camera.setSubnetmask(revList.get(j));
            			break;
            		case 9:
            			//网关
            			if (revList.get(j) != null && !"".equals(revList.get(j))) {
            				value_flag = revList.get(j).matches(ip);
            				if (!value_flag) {
                    			msg = "第 "+(i+1)+" 行的第 10 列的值不符合IP规范！";
                    			return msg;
                    		}
            			}
            			camera.setGateway(revList.get(j));
            			break;
            		case 10:
            			//设备类型
            			if (!"1".equals(revList.get(j)) && !"2".equals(revList.get(j))) {
        					msg = "第 "+(i+1)+" 行第 11 列的值必须是1或者2！";
        					return msg;
        				}
//			            index = revList.get(j).indexOf("-");
//			            value = revList.get(j).substring(0, index);
            			camera.setType(revList.get(j));
            			break;
            		case 11:
            			//设备端口
            			value_flag = revList.get(j).matches("[0-9]+");
                		if (!value_flag) {
                			msg = "第 "+(i+1)+" 行的第 12 列的值只能是数字！";
                			return msg;
                		}
                		len = revList.get(j).length();
                		if (len > 10) {
                			msg = "第 "+(i+1)+" 行第 12 列的值的长度不能超过10！";
                			return msg;
                		}
            			camera.setPort(revList.get(j));
            			break;
            		case 12:
            			//设备型号
            			if (revList.get(j) != null && !"".equals(revList.get(j))) {
            				len = revList.get(j).length();
            				if (len > 50) {
            					msg = "第 "+(i+1)+" 行第 13 列的值的长度不能超过50！";
            					return msg;
            				}
            			}
            			camera.setModelNumber(revList.get(j));
            			break;
            		case 13:
            			//所在位置
            			if (revList.get(j) != null && !"".equals(revList.get(j))) {
            				if (!"1".equals(revList.get(j)) && !"2".equals(revList.get(j))) {
            					msg = "第 "+(i+1)+" 行第 14 列的值必须是1或者2！";
            					return msg;
            				}
            			}
            			camera.setLive(revList.get(j));
            			break;
            		case 14:
            			//设备序列号
            			if (revList.get(j) != null && !"".equals(revList.get(j))) {
            				len = revList.get(j).length();
            				if (len > 20) {
            					msg = "第 "+(i+1)+" 行第 15 列的值的长度不能超过20！";
            					return msg;
            				}
            			}
            			camera.setSerialNumber(revList.get(j));
            			break;
            		case 15:
            			//安装位置
            			if (revList.get(j) != null && !"".equals(revList.get(j))) {
            				len = revList.get(j).length();
            				if (len > 50) {
            					msg = "第 "+(i+1)+" 行第 16 列的值的长度不能超过50！";
            					return msg;
            				}
            			}
            			camera.setInstallationSite(revList.get(j));
            			break;
            		case 16:
            			//安装方式
            			if (revList.get(j) != null && !"".equals(revList.get(j))) {
            				len = revList.get(j).length();
            				if (len > 20) {
            					msg = "第 "+(i+1)+" 行第 17 列的值的长度不能超过20！";
            					return msg;
            				}
            			}
            			camera.setInstallationMethod(revList.get(j));
            			break;
            		case 17:
            			//照射区域
            			if (revList.get(j) != null && !"".equals(revList.get(j))) {
            				len = revList.get(j).length();
            				if (len > 50) {
            					msg = "第 "+(i+1)+" 行第 18 列的值的长度不能超过50！";
            					return msg;
            				}
            			}
            			camera.setIrradiatedArea(revList.get(j));
            			break;
            		case 18:
            			//取电位置
            			if (revList.get(j) != null && !"".equals(revList.get(j))) {
            				len = revList.get(j).length();
            				if (len > 50) {
            					msg = "第 "+(i+1)+" 行第 19 列的值的长度不能超过50！";
            					return msg;
            				}
            			}
            			camera.setPowerPosition(revList.get(j));
            			break;
            		case 19:
						//仓房名称
						if (revList.get(j) != null && !"".equals(revList.get(j))) {
							len = revList.get(j).length();
							if (len > 50) {
								msg = "第 "+(i+1)+" 行第 20 列的值的长度不能超过50！";
								return msg;
							}
						}

						if(ParameterUtil.isnotnull(revList.get(j)) && ParameterUtil.isequal(revList.get(13),"1")){
							enumData.put("storehouseName", revList.get(j));
							enumData.put("orgId", orgId);
							Map<String,Object> storehouseId = cameraStorehouseMapper.getStorehouseId(enumData);
							if(ParameterUtil.isnull(storehouseId)){
								msg = "第 "+(i+1)+" 行第 20 列的值的不正确，请查询后再添加！";
								return msg;
							}

							cameraStorehouse = new CameraStorehouse();
							cameraStorehouse.setOrgId(orgId);
							cameraStorehouse.setStorehouseId(Integer.parseInt(storehouseId.get("storehouseId").toString()));
						}
						camera.setPowerPosition(revList.get(j));
						break;
					case 20:
						//摄像头唯一标识
						if (revList.get(j) != null && !"".equals(revList.get(j))) {
							len = revList.get(j).length();
							if (len > 50) {
								msg = "第 "+(i+1)+" 行第 21 列的值的长度不能超过50！";
								return msg;
							}
						}
						if(ParameterUtil.isnotnull(revList.get(j))){
							enumData.put("cameraIndexCode", revList.get(j));
							Map<String,Object> ca = cameraStorehouseMapper.getCameraIndexCode(enumData);
							if(!ParameterUtil.isnull(ca)){
								msg = "第 "+(i+1)+" 行第 21 列的值的不正确，请查询后再添加！";
								return msg;
							}
						}
						camera.setCameraIndexCode(revList.get(j));
						break;

					case 21:
						//在线状态（0-未知，1-在
						//线，2-离线）
						Integer status =0;
						if (revList.get(j) != null && !"".equals(revList.get(j))) {
							len = revList.get(j).length();
							if (!"0".equals(revList.get(j)) && !"1".equals(revList.get(j)) && !"2".equals(revList.get(j))) {
								msg = "第 "+(i+1)+" 行第 22 列的值必须是0或者1或者2！";
								return msg;
							}
							 status=Integer.parseInt(revList.get(j));
						}
						camera.setStatus(status);
						break;
            		default :
            			break;
            	}
            }
			int a =cameraMapper.insert(camera);
			if(a>0){
				msg="导入成功";
			}

            if(ParameterUtil.isnotnull(cameraStorehouse)){
				cameraStorehouse.setCameraId(camera.getId());
				cameraStorehouseMapper.insert(cameraStorehouse);
				cameraStorehouse = null;
			}
		}
        return msg;
	}

}
