package com.chinaitop.depot.hk.dto.req;

import lombok.Data;

/**
 * 获取监控点预览取流 获取监控点预览取流  URLv2
 *
 * @author ybw
 * @version V1.0
 * @className PreviewReqVO
 * @date 2024/6/20
 **/
@Data
public class Preview2ReqDTO {
    /**
     * 监控点编号
     *
     * @author: ybw
     * @date: 2024/6/19
     **/
    private String cameraIndexCode;

    /**
     * 取流协议（应用层协议），
     * “hik”:HIK私有协议，使用视频SDK进行播放时，传入此类型；
     * “rtsp”:RTSP协议；
     * “rtmp”:RTMP协议（RTMP协议只支持海康SDK协议、EHOME协议、ONVIF协议接入的设备；只支持H264视频编码和AAC音频编码）；
     * “hls”:HLS协议（HLS协议只支持海康SDK协议、EHOME协议、ONVIF协议接入的设备；只支持H264视频编码和AAC音频编码）；
     * “ws”:Websocket协议（一般用于H5视频播放器取流播放）。
     * 参数不填，默认为HIK协议
     */
    private String protocol;

    public Preview2ReqDTO(PreviewReqDTO previewReqDTO) {
        this.cameraIndexCode = previewReqDTO.getCameraIndexCode();
        this.protocol = previewReqDTO.getProtocol().getName();
    }
}
