package com.chinaitop.depot.hk.dto.res;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * 批量获取监控点的预置点信息
 *
 * @author ybw
 * @version V1.0
 * @className PresetsReqDTO
 * @date 2024/8/2
 **/
@Data
@NoArgsConstructor
@AllArgsConstructor
public class PresetsResDTO {

    /**
     * 结果总数
     *
     * @author: ybw
     * @date: 2024/8/2
     **/
    private int total;
    /**
     * 监控点预置点信息列表
     *
     * @author: ybw
     * @date: 2024/8/2
     **/
    private List<ListBean> list;


    @Data
    public static class ListBean {

        /**
         * 监控点编号
         *
         * @author: ybw
         * @date: 2024/8/2
         **/
        private String cameraIndexCode;
        /**
         * 预置点信息
         *
         * @author: ybw
         * @date: 2024/8/2
         **/
        private List<PresetPointsBean> presetPoints;

        @Data
        public static class PresetPointsBean {

            /**
             * 预置点名称
             *
             * @author: ybw
             * @date: 2024/8/2
             **/
            private String presetPointName;
            /**
             * 预置点编号
             *
             * @author: ybw
             * @date: 2024/8/2
             **/
            private int presetPointIndex;

        }
    }
}
