package com.chinaitop.depot.monitor.service;

import com.chinaitop.depot.monitor.model.MonitorAlarm;
import com.chinaitop.depot.monitor.model.MonitorAlarmExample;
import com.chinaitop.depot.monitor.model.MonitorAlarmType;
import com.chinaitop.depot.monitor.model.MonitorAlarmTypeExample;

import java.util.List;

public interface MonitorAlarmService {

    /**
     * 根据条件查询摄像头列表数据
     * @param example
     * @return
     */
    List<MonitorAlarm> queryByExample(MonitorAlarmExample example);

    /**
     * 根据id获取摄像头详情数据
     * @param id
     * @return
     */
    MonitorAlarm findById(Integer id);

    /**
     * 添加报警信息
     * @param user
     */
    void addAlarm(MonitorAlarm user);

    void update(MonitorAlarmType user);

    /**
     * 获取报警设置信息
     */
    List<MonitorAlarmType> getAlarmType(MonitorAlarmTypeExample example);

    /**
     * 添加报警设置信息
     * @param alarmType
     */
    void addAlarmType(MonitorAlarmType alarmType);

}
