package com.chinaitop.depot.monitor.service;

import com.chinaitop.depot.monitor.model.*;

import java.util.List;
import java.util.Map;

/**
 * 质量诊断
 */
public interface QualityDlagService {
    /**
     * 条件查询计划列表
     * @param example
     * @return
     */
    List<DiagPlan> selectByExampleForPlan(DiagPlanExample example);

    /**
     * 根据id获取计划信息
     * @param planId
     * @return
     */
    DiagPlan selectPlanById(Integer planId);
    
    /**
     * 根据定时id获取计划信息
     * @param planId
     * @return
     */
    DiagPlan selectPlanByQuartzid(String quartzid);

    /**
     * 保存计划
     * @param planJson
     */
    Map<String,String> savePlan(String planJson,Integer orgId,Integer userId);

    //计划删除
    void removePlanById(Integer planId);
    /**
     * 条件查询结果列表
     * @param map
     * @return
     */
    List<Map<String,Object>> selectByExampleForResult(Map<String,Object> map);
    /**
     * 条件查询结果列表
     * @param map
     * @return
     */
    List<Map<String,Object>> selectNewTimeList(Map<String,Object> map);

    /**
     * 获取异常摄像头总数
     * @return
     */
    Integer getCountForZdResult(Map<String,Object> map);


    /**
     * 阈值管理页面
     * @param example
     * @return
     */
    List<DiagKind> selectByExampleForKind(DiagKindExample example);

    /**
     * 修改阈值
     * @param kind
     * @return
     */
    void updateByPrimaryKeySelective(DiagKind kind);


    /**
     * 一键修改阈值
     * @return
     */
    void allSave(String val,String index);



    //根据定时器id查询计划对象
    DiagPlan getDlagPlanByQuartzId(String quartzId);

}
