package com.chinaitop.depot.monitor.service.impl;

import com.chinaitop.depot.monitor.mapper.MonitorAlarmPhoneMapper;
import com.chinaitop.depot.monitor.model.MonitorAlarmPhone;
import com.chinaitop.depot.monitor.model.MonitorAlarmPhoneExample;
import com.chinaitop.depot.monitor.service.AlarmSettingService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@Service
public class AlarmSettingServiceImpl implements AlarmSettingService {

    @Resource
    private MonitorAlarmPhoneMapper monitorAlarmPhoneMapper;
    /**
     * 获取路径数据
     * @return
     */
    @Override
    public List<MonitorAlarmPhone> getAlarmPhone(MonitorAlarmPhoneExample example) {
        return monitorAlarmPhoneMapper.selectByExample(example);
    }

    /**
     * 保存当前数据
     * @param monitorAlarmPhone
     */
    @Override
    public void saveAlarmPhone(MonitorAlarmPhone monitorAlarmPhone) {
        monitorAlarmPhoneMapper.insert(monitorAlarmPhone);
    }

    @Override
    public void deleteAlarmPhone(Integer alarmId) {
        monitorAlarmPhoneMapper.deleteByPrimaryKey(alarmId);
    }

    @Override
    public List<MonitorAlarmPhone> getAllAlarmPhone(Integer orgId) {
        MonitorAlarmPhoneExample example = new MonitorAlarmPhoneExample();
        MonitorAlarmPhoneExample.Criteria criteria = example.createCriteria();
        criteria.andOrgIdEqualTo(orgId);
        return monitorAlarmPhoneMapper.selectByExample(example);
    }
}
