package com.chinaitop.depot.monitor.service.impl;

import com.chinaitop.depot.monitor.mapper.MonitorSettingPathMapper;
import com.chinaitop.depot.monitor.model.MonitorSettingPath;
import com.chinaitop.depot.monitor.model.MonitorSettingPathExample;
import com.chinaitop.depot.monitor.service.CameraSettingService;
import com.chinaitop.depot.utils.ParameterUtil;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * @auther mafy
 * @createtime 2017/10/25 0025
 */
@Service
public class CameraSettingServiceImpl implements CameraSettingService{

    @Resource
    private MonitorSettingPathMapper monitorSettingPathMapper;
    /**
     * 获取路径数据
     * @return
     */
    @Override
    public MonitorSettingPath getAllPath(MonitorSettingPathExample example) {
        MonitorSettingPath monitorSettingPath= null;
        List<MonitorSettingPath> list = monitorSettingPathMapper.selectByExample(example);
        if (list.size()>0)
            monitorSettingPath =list.get(0);
        else
            monitorSettingPath = new MonitorSettingPath();

        return monitorSettingPath;
    }

    /**
     * 保存当前数据
     * @param monitorSettingPath
     */
    @Override
    public void setAllPath(MonitorSettingPath monitorSettingPath) {
        if(ParameterUtil.isnotnull(monitorSettingPath.getId())){
            monitorSettingPathMapper.updateByPrimaryKeySelective(monitorSettingPath);
        }else{
            monitorSettingPathMapper.insertSelective(monitorSettingPath);
        }
    }
}
