package com.chinaitop.depot.monitor.service.impl;

import com.chinaitop.depot.monitor.mapper.GroupMapper;
import com.chinaitop.depot.monitor.model.Group;
import com.chinaitop.depot.monitor.model.GroupExample;
import com.chinaitop.depot.monitor.service.GroupService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.beans.Transient;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @auther mafy
 * @createtime 2017/10/22 0022
 */
@Service
public class GroupServiceImpl implements GroupService {

    @Resource
    private GroupMapper groupMapper;
    @Override
    public List<Group> selectByExampleForPlan(GroupExample example) {
        return groupMapper.selectByExample(example);
    }

    @Override
    public void add(Group group) {
        groupMapper.insertSelective(group);
    }

    @Override
    public void update(Group group) {
        groupMapper.updateByPrimaryKeySelective(group);
    }

    @Override
    @Transient
    public Map<String, String> removebyid(Integer groupid) {
        groupMapper.deleteByPrimaryKey(groupid);//分组表
        groupMapper.deleteGroupCameraByPrimaryKey(groupid);//关系表删除
        return null;
    }

    @Override
    public List<Map<String, Object>> queryCameraForGroup(Map<String, Object> map) {

        return groupMapper.queryCameraForGroup(map);
    }

    @Override
    public Map<String, String> editGroupCamera(Integer groupid, Integer cameraid, Integer type) {
        Map<String,Object> map = new HashMap<String, Object>();
        map.put("groupid",groupid);
        map.put("cameraid",cameraid);
        if(type == 0){//删除
            groupMapper.deleteGroupCamera(map);
        }else if(type == 1){//新增
            groupMapper.insertGroupCamera(map);
        }else if(type == 3){//删除这个分组下的所有摄像头
            groupMapper.deleteGroupCameraByPrimaryKey(groupid);//关系表删除
        }
        return null;
    }

    /**
     * 获取到最后一个分组id
     *
     * @return
     */
    @Override
    public Map<String,Object> getGroupIdLast(Map<String,Object> map) {
        return groupMapper.getGroupIdLast(map);
    }
}
