package com.chinaitop.depot.monitor.service.impl;

import com.chinaitop.depot.monitor.mapper.MonitorAlarmMapper;
import com.chinaitop.depot.monitor.mapper.MonitorAlarmTypeMapper;
import com.chinaitop.depot.monitor.model.MonitorAlarm;
import com.chinaitop.depot.monitor.model.MonitorAlarmExample;
import com.chinaitop.depot.monitor.model.MonitorAlarmType;
import com.chinaitop.depot.monitor.model.MonitorAlarmTypeExample;
import com.chinaitop.depot.monitor.service.MonitorAlarmService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@Service
public class MonitorAlarmServiceImpl implements MonitorAlarmService {

    @Resource
    private MonitorAlarmMapper alarmMapper;

    @Resource
    private MonitorAlarmTypeMapper alarmMapperType;

    @Override
    public List<MonitorAlarm> queryByExample(MonitorAlarmExample example) {
        return alarmMapper.selectByAlarm(example);
    }

    @Override
    public MonitorAlarm findById(Integer id) {
        return alarmMapper.selectByPrimaryKey(id);
    }

    @Override
    public void addAlarm(MonitorAlarm alarm) {
        alarmMapper.insert(alarm);
    }

    @Override
    public void update(MonitorAlarmType alarm) {
        alarmMapperType.updateByPrimaryKey(alarm);
    }

    @Override
    public List<MonitorAlarmType> getAlarmType(MonitorAlarmTypeExample example) {
        return alarmMapperType.selectByExample(example);
    }

    @Override
    public void addAlarmType(MonitorAlarmType alarmType) {
        alarmMapperType.insert(alarmType);
    }
}
