package com.chinaitop.depot.monitor.service.impl;

import com.chinaitop.depot.basic.model.MonitorCamera;
import com.chinaitop.depot.basic.model.MonitorCameraExample;
import com.chinaitop.depot.basic.service.MonitorCameraService;
import com.chinaitop.depot.hk.dto.req.CameraReqDTO;
import com.chinaitop.depot.hk.dto.res.CameraResDTO;
import com.chinaitop.depot.hk.service.HkService;
import com.chinaitop.depot.monitor.service.MonitorService;

import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;

@Service
public class MonitorServiceImpl implements MonitorService {

    @Resource
    private MonitorCameraService cameraService;

    @Resource
    private HkService hkService;

    @Transactional
    @Override
    public void updateMonitorStatus() {
        //查询所有摄像头
        MonitorCameraExample example = new MonitorCameraExample();
        MonitorCameraExample.Criteria criteria = example.createCriteria();
        criteria.andIsremoveEqualTo("1");//默认加载未删除的数据
        List<MonitorCamera> list = cameraService.queryByExample(example);
        Integer status;

        if (!list.isEmpty()) {
            for (MonitorCamera camera : list) {
                if(camera.getCameraIndexCode()!=null){
                    MonitorCamera monitorCamera =new MonitorCamera();
                    CameraResDTO resDTO= hkService.getCamera(new CameraReqDTO(camera.getCameraIndexCode()));
                    if(resDTO.getStatus()!=null){
                        if("0".equals(resDTO.getStatus())){
                            status=0;
                            monitorCamera.setWarnTime(new Date());
                        }
                        status=Integer.parseInt(resDTO.getStatus());
                    }else{
                        status=0;

                    }
                    monitorCamera.setId(camera.getId());
                    monitorCamera.setStatus(status) ;
                    cameraService.update(monitorCamera);
                }
            }
        } else {

            System.out.println("暂无数据需要更新");
        }

    }
}
