package com.chinaitop.depot.monitor.service.impl;

import com.chinaitop.depot.basic.mapper.MonitorCameraMapper;
import com.chinaitop.depot.basic.model.MonitorCamera;
import com.chinaitop.depot.monitor.mapper.DiagResultMapper;
import com.chinaitop.depot.monitor.mapper.MonitorAlarmMapper;
import com.chinaitop.depot.monitor.model.*;
import com.chinaitop.depot.monitor.service.AlarmSettingService;
import com.chinaitop.depot.monitor.service.QualityDlagService;
import com.chinaitop.depot.monitor.util.MonitorZD;
import com.chinaitop.depot.monitor.util.SendMessage;
import com.chinaitop.depot.monitor.util.SendMessagePT.SendMessagePT;
import com.chinaitop.depot.monitor.util.SendMessagePT.SmsDataVO;
import com.chinaitop.depot.utils.ParameterUtil;
import com.chinaitop.depot.utils.Ping;
import com.chinaitop.depot.utils.activiti.SpringContextHolder;
import org.springframework.beans.factory.annotation.Value;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.*;

/**
 * @auther mafy
 * @createtime 2017/10/24 0024
 */
public class MonitorZDService {

    private DiagPlan diagPlan;

    private String[] DiagAllObj = {"画面冻结","图像过亮","图像过暗","对比度","视频遮挡","黑白图像","图像偏色","信号丢失","视频剧变","图像模糊","噪声干扰","场景变更","视频抖动","条纹干扰","云台失控"};

    public MonitorZDService(DiagPlan diagPlan){ this.diagPlan = diagPlan;}

    private MonitorZDService(){}

    public void MonitorZd(){

        //初始化dll文件
        //initDLL();

        //查询出分组id对应的所有摄像头
        List<List<MonitorCamera>> groupList = getAllCameraByGroupId();

        //TODO 遍历分组list，在分组中再遍历每一个摄像头，进行诊断
        for (int i = 0; i < groupList.size(); i++) {
            eachGroup(groupList.get(i));
        }
    }

    /**
     * 获取分组的摄像头
     * 最外层是所有分组，里面的list是每一个分组里的所有摄像头
     * @return
     */
    private List<List<MonitorCamera>> getAllCameraByGroupId(){
        String[] groupStr = diagPlan.getGroupId().split(",");//所有分组的id

        //获取到所有的分组对应的摄像头
        MonitorCameraMapper monitorCameraMapper = SpringContextHolder.getBean(MonitorCameraMapper.class);
        List<List<MonitorCamera>> groupList = new ArrayList();
        for (int i = 0; i <groupStr.length; i++) {//每一个分组
            List<Map<String,Object>> CameraList;
            if(ParameterUtil.isequal(groupStr[0],"0")){
                Map<String,Object> retMap = new HashMap<String,Object>();
                retMap.put("orgid",this.diagPlan.getOrgId());
                CameraList = monitorCameraMapper.selectByNVRDates(retMap);
            }else{
                CameraList = monitorCameraMapper.selectByGroupId(groupStr[i]);
            }
            List<MonitorCamera> monitorCameraList = new ArrayList<MonitorCamera>();
            for (int j = 0; j < CameraList.size(); j++) {
                //c.id,c.ip,c.username,c.`password`,c.`port`,c.factory, c.type
                MonitorCamera monitorCamera = new MonitorCamera();
                monitorCamera.setOrgId(CameraList.get(j).get("org_id").toString());
                monitorCamera.setId(Integer.parseInt(CameraList.get(j).get("camera_id").toString()));
                monitorCamera.setAlias(CameraList.get(j).get("alias").toString());
                monitorCamera.setIp(CameraList.get(j).get("camera_ip").toString());
                monitorCamera.setUsername(CameraList.get(j).get("camera_name").toString());
                monitorCamera.setPassword(CameraList.get(j).get("camera_password").toString());
                monitorCamera.setPort(CameraList.get(j).get("camera_port").toString());
                monitorCamera.setFactory(CameraList.get(j).get("factory").toString());
                monitorCamera.setType(CameraList.get(j).get("camera_type").toString());
                monitorCameraList.add(monitorCamera);
            }
            groupList.add(monitorCameraList);
        }
        return groupList;
    }

    /**
     * 这里面是每一个分组里面的所有摄像头，诊断方式在这里面
     * @param cameraList
     */
    private void eachGroup(List<MonitorCamera> cameraList){
        for (int i = 0; i < cameraList.size(); i++) {//这里面是每一个摄像头

            //首先摄像头进行ping,不通的话直接插入数据库
            if(!PintCameraByIp(cameraList.get(i).getIp())){
                String[] ZDResult = {"0","0","0","0","0","0","0","100","0","0","0","0","0","0","0","NO"};
                insertZDResult(ZDResult,cameraList.get(i));
            }else{
                String[] ZDResult = {"0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","NO"};
                insertZDResult(ZDResult,cameraList.get(i));
            }
//            else{
//                //该处进行诊断
//                String[] cameraZDResult = ZDMonitor(cameraList.get(i));
//                //TODO 将诊断结果插入到结果表中
//                if(ParameterUtil.isnotnull(cameraZDResult)){//如果诊断结果不为空，则进行数据库插入
//                    insertZDResult(cameraZDResult,cameraList.get(i));
//                }
//            }
        }
    }

    /**
     * ping摄像头
     * @param CameraIp
     * @return
     */
    private boolean PintCameraByIp(String CameraIp){
        Ping p = new Ping(CameraIp, 1, 5000);
        return p.isReachable();
    }

    /**
     * 针对每一个摄像头进行诊断，返回诊断结果
     * @param monitorCamera
     */
    private String[] ZDMonitor(MonitorCamera monitorCamera){
        System.out.println("摄像头("+monitorCamera.getAlias()+")开始进行诊断");
        String zdret = "";

        MonitorZD monitorZD = MonitorZD.getMonitorZDObj();
        // 当前诊断结果为15项，每一项对应的是DiagAllObj里面的每一个值

        //开始诊断    设备IP,设备端口,设备用户名,设备密码,厂商类型(海康1;大华2),设备类型(球机1,枪机2),诊断项目(1诊断,0不诊断),文件路径(诊断截图)
//        String zdvalue="111111111111111";
        String zdvalue= diagPlan.getFreeze().toString() + diagPlan.getBright().toString() + diagPlan.getDark().toString() + diagPlan.getContrast().toString()
                + diagPlan.getCover().toString() + diagPlan.getMono().toString() + diagPlan.getChroma().toString() + diagPlan.getSignals().toString()
                + diagPlan.getFlash().toString() + diagPlan.getBlur().toString() + diagPlan.getNoise().toString() + diagPlan.getScene().toString()
                + diagPlan.getHake().toString() + diagPlan.getStripe().toString() + diagPlan.getPtz().toString();

        //获取监测信息放置文件夹
        String urlProfile = "/bootstrap.yml";
        Properties pt = this.readProperties(urlProfile);
        String os = System.getProperty("os.name");
        String rootPath = "";
        if(os.toLowerCase().startsWith("win")){
            rootPath = pt.getProperty("windows-path");
        }else{
            rootPath = pt.getProperty("linux-path");
        }

        //判断厂商类型..默认海康的
        Integer factory = 1;
        if(monitorCamera.getFactory() == "300"){
            factory = 2;
        }

        int ret = 0;
        ret = monitorZD.Start(monitorCamera.getIp(),
                Integer.parseInt(monitorCamera.getPort()),
                monitorCamera.getUsername(),
                monitorCamera.getPassword(),
                factory,
                Integer.parseInt(monitorCamera.getType()),//球机的话检测会转一圈，枪机不会
                zdvalue,rootPath);

        if(ret == 0){//成功
            //诊断方法成功返回之后，开始调用方法获取诊断结果，3s之后获取不到，则返回null
            for (int i = 0; i < 3; i++) {
                try {
                    Thread.sleep(1000);
                    if(ParameterUtil.isequal("",zdret))
                        zdret = monitorZD.GetValue();
//                        zdret = "10|F-G|10|F-G|10|F-G|10|F-G|10|F-G|10|F-G|10|F-G|10|F-G|10|F-G|10|F-G|10|F-G|10|F-G|10|F-G|10|F-G|10|F-G|NO";
                    else
                        return zdret.split("\\|F-G\\|");
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
        }
        System.out.println(monitorCamera.getAlias()+"诊断失败，返回NULL");
        return null;
    }

    /**
     * 将诊断结果插入到数据库中
     * @param zdArr
     */
    private void insertZDResult(String[] zdArr,MonitorCamera camera){
        //获取阈值
        DiagResultMapper diagResultMapper = SpringContextHolder.getBean(DiagResultMapper.class);
        DiagResult diagResult = new DiagResult();

        if (zdArr != null){
            StringBuilder sms = new StringBuilder();
            diagResult.setCameraId(camera.getId());//摄像头id
            diagResult.setOrgId(Integer.parseInt(camera.getOrgId()));//orgid
            diagResult.setCreateTime(ParameterUtil.string2datetime(ParameterUtil.getSysDateTime()));//时间
            diagResult.setFreeze(zdArr[0]);//"画面冻结"
            diagResult.setBright(zdArr[1]);//图像过亮
            diagResult.setDark(zdArr[2]);//图像过暗
            diagResult.setContrast(zdArr[3]);//对比度
            diagResult.setCover(zdArr[4]);//视频遮挡
            diagResult.setMono(zdArr[5]);//黑白图像
            diagResult.setChroma(zdArr[6]);//图像偏色
            diagResult.setSignals(zdArr[7]);//信号丢失
            diagResult.setFlash(zdArr[8]);//视频剧变
            diagResult.setBlur(zdArr[9]);//图像模糊
            diagResult.setNoise(zdArr[10]);//噪声干扰
            diagResult.setScene(zdArr[11]);//场景变更
            diagResult.setShake(zdArr[12]);//视频抖动
            diagResult.setStripe(zdArr[13]);//条纹干扰
            diagResult.setPtz(zdArr[14]);//云台失控
            diagResult.setImg(zdArr[15]);//图片路径
            if(ParameterUtil.isequal("100",diagResult.getSignals())){//排除ping不通的情况//iserrorZd(zdArr) &&
                diagResult.setResult("2");//最终诊断结果:诊断失败
            }else{
                diagResult.setResult(getDiagKindList(diagResult,sms));//最终诊断结果：0无异常，1有异常
            }
            diagResultMapper.insertSelective(diagResult);
            //todo 短信发送
//            sendMsg(sms.toString(),camera.getAlias(),zdArr[15],camera.getId().toString());
        }
    }

    /**
     * 获取阈值，且拼接短信
     * @return
     */
    private String getDiagKindList(DiagResult diagResult,StringBuilder sms){

        QualityDlagService dlagService = SpringContextHolder.getBean(QualityDlagService.class);
        DiagKindExample example = new DiagKindExample();
        DiagKindExample.Criteria criteria = example.createCriteria();
        List<DiagKind> list = dlagService.selectByExampleForKind(example);

        String result = "0";

        for (int i = 0; i < list.size(); i++) {
            DiagKind diagKind = list.get(i);
            if(ParameterUtil.isequal(diagKind.getId(),1)){
                if(Integer.parseInt(diagResult.getBlur())>diagKind.getNewScore()){//诊断分值大于默认阀值
                    result = "1";
                    sms.append("·图像模糊·");
                    break;
                }
            }else if(ParameterUtil.isequal(diagKind.getId(),2)){
                if(Integer.parseInt(diagResult.getChroma())>diagKind.getNewScore()){//诊断分值大于默认阀值
                    result = "1";
                    sms.append("·偏色异常·");
                    break;
                }
            }else if(ParameterUtil.isequal(diagKind.getId(),3)){
                if(Integer.parseInt(diagResult.getFreeze())>diagKind.getNewScore()){//诊断分值大于默认阀值
                    result = "1";
                    sms.append("·画面冻结·");
                    break;
                }
            }else if(ParameterUtil.isequal(diagKind.getId(),4)){
                if(Integer.parseInt(diagResult.getScene())>diagKind.getNewScore()){//诊断分值大于默认阀值
                    result = "1";
                    sms.append("·场景变更·");
                    break;
                }
            }else if(ParameterUtil.isequal(diagKind.getId(),5)){
                if(Integer.parseInt(diagResult.getSignals())>diagKind.getNewScore()){//诊断分值大于默认阀值
                    result = "1";
                    sms.append("·信号丢失·");
                    break;
                }
            }else if(ParameterUtil.isequal(diagKind.getId(),6)){
                if(Integer.parseInt(diagResult.getPtz())>diagKind.getNewScore()){//诊断分值大于默认阀值
                    result = "1";
                    sms.append("·云台失控·");
                    break;
                }
            }else if(ParameterUtil.isequal(diagKind.getId(),7)){
                if(Integer.parseInt(diagResult.getContrast())>diagKind.getNewScore()){//诊断分值大于默认阀值
                    result = "1";
                    sms.append("·对比度异常·");
                    break;
                }
            }else if(ParameterUtil.isequal(diagKind.getId(),8)){
                if(Integer.parseInt(diagResult.getBright())>diagKind.getNewScore()){//诊断分值大于默认阀值
                    result = "1";
                    sms.append("·图像过亮·");
                    break;
                }
            }else if(ParameterUtil.isequal(diagKind.getId(),9)){
                if(Integer.parseInt(diagResult.getDark())>diagKind.getNewScore()){//诊断分值大于默认阀值
                    result = "1";
                    sms.append("·图像过暗·");
                    break;
                }
            }else if(ParameterUtil.isequal(diagKind.getId(),10)){
                if(Integer.parseInt(diagResult.getMono())>diagKind.getNewScore()){//诊断分值大于默认阀值
                    result = "1";
                    sms.append("·黑白图像·");
                    break;
                }
            }else if(ParameterUtil.isequal(diagKind.getId(),11)){
                if(Integer.parseInt(diagResult.getNoise())>diagKind.getNewScore()){//诊断分值大于默认阀值
                    result = "1";
                    sms.append("·噪音干扰·");
                    break;
                }
            }else if(ParameterUtil.isequal(diagKind.getId(),12)){
                if(Integer.parseInt(diagResult.getStripe())>diagKind.getNewScore()){//诊断分值大于默认阀值
                    result = "1";
                    sms.append("·条纹干扰·");
                    break;
                }
            }else if(ParameterUtil.isequal(diagKind.getId(),13)){
                if(Integer.parseInt(diagResult.getShake())>diagKind.getNewScore()){//诊断分值大于默认阀值
                    result = "1";
                    sms.append("·视频抖动·");
                    break;
                }
            }else if(ParameterUtil.isequal(diagKind.getId(),14)){
                if(Integer.parseInt(diagResult.getFlash())>diagKind.getNewScore()){//诊断分值大于默认阀值
                    result = "1";
                    sms.append("·视频巨变·");
                    break;
                }
            }else if(ParameterUtil.isequal(diagKind.getId(),15)){
                if(Integer.parseInt(diagResult.getCover())>diagKind.getNewScore()){//诊断分值大于默认阀值
                    result = "1";
                    sms.append("·视频遮挡·");
                    break;
                }
            }
        }//for结束
        return result;
    }

    /**
     * 是否诊断失败
     * @param zdArr
     * @return
     */
    private boolean iserrorZd(String[] zdArr){
        int counts = 0;
        for (int i = 0; i < zdArr.length; i++) {
            if(ParameterUtil.isequal("0",zdArr[i]))
                counts +=1;
        }
        if(counts>=14){
            return true;
        }
        return false;
    }


    /**
     * 短信发送
     * @param sms 短信异常内容
     * @param cameraAlias 摄像头名称
     */
    private void sendMsg(String sms ,String cameraAlias,String imgPath,String cameraID){
        //发短信功能模块
//        SendMessage sendMessage = new SendMessage();//--短信猫
        SendMessagePT sendMessagePT = new SendMessagePT();//--短信平台

        String sendMsg = "";
        //如果有报警信息
        if(!sms.toString().isEmpty()){
            sendMsg+="摄像头（"+cameraAlias+"）检测有问题，问题如下：" +sms;
            // 记录报警信息
            MonitorAlarmMapper alarmMapper = SpringContextHolder.getBean(MonitorAlarmMapper.class);

            MonitorAlarm alarm = new MonitorAlarm();
            alarm.setAlarmName("质量诊断检测");
            alarm.setAlarmType("短信报警");
            alarm.setImgPath(imgPath);
            alarm.setCameraId(Integer.valueOf(cameraID));
            alarm.setAlarmGrade("2");
            alarm.setAlarmContent(sendMsg);
            alarm.setOrgId(this.diagPlan.getOrgId());
            alarm.setAlarmTime(ParameterUtil.string2date(ParameterUtil.getSysDateTime()));//修改时间

            alarmMapper.insert(alarm);

            //查询出手机号码
            AlarmSettingService alarmSettingService = SpringContextHolder.getBean(AlarmSettingService.class);
            List<MonitorAlarmPhone> phone = alarmSettingService.getAllAlarmPhone(this.diagPlan.getOrgId());
            //发送短信
//            sendMessage.sendSMS(phone.get(0).getAlarmPhone(), sendMsg);
            try {
                SmsDataVO smsDataVO = new SmsDataVO();
                smsDataVO.setSdst(phone.get(0).getAlarmPhone());
                smsDataVO.setSmsg(sendMsg);
                sendMessagePT.sendingSMS(smsDataVO);
            } catch (Exception e) {
                e.printStackTrace(System.out);
            }
        }
    }

    public static void main(String[] args){
        for (int i = 0; i < 10; i++) {
            try {
                SendMessagePT sendMessagePT = new SendMessagePT();
                SmsDataVO smsDataVO = new SmsDataVO();
                smsDataVO.setSdst("18272732624");
                smsDataVO.setSmsg("哈哈");
                sendMessagePT.sendingSMS(smsDataVO);
            } catch (Exception e) {
                e.printStackTrace(System.out);
            }
        }

    }

    //初始化dll文件
    private void initDLL(){
//        System.out.println(System.getProperty("java.library.path"));
        try {
            System.loadLibrary("MonitorZD");
//            HCMonitorZDAction  monitorZD = SpringContextHolder.getBean(HCMonitorZDAction .class);
            MonitorZD monitorZD = MonitorZD.getMonitorZDObj();
            monitorZD.InitHCSdk();
            monitorZD.InitDHSdk();
        } catch (Exception e) {
            System.out.println("DLL文件加载失败，视频诊断模块不可使用");
            //e.printStackTrace();
        }
    }

    public static Properties readProperties(String filePath) {
        Properties props = new Properties();
        try {
            InputStream in = new BufferedInputStream(MonitorZDService.class.getResourceAsStream(filePath));
            props.load(in);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return props;
    }
}
