package com.chinaitop.depot.monitor.util;

import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.Date;
import java.util.TimeZone;
import java.util.UUID;

/**
 * @auther mafy
 * @createtime 2017/10/20 0020
 */
public class MonitorZDTest {
    public static void main(String[] args) {
        System.out.println(System.getProperty("java.library.path"));
        SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss:SS");
        TimeZone t = sdf.getTimeZone();
        t.setRawOffset(0);
        sdf.setTimeZone(t);
        //开始时间
        Long startTime = System.currentTimeMillis();
        //诊断对象
        MonitorZD dm = null;
        String path="E:/monitorzd/",zdvalue="000011111110000";
        System.loadLibrary("MonitorZD");
        dm = new MonitorZD();
        //加载信息
        dm.InitLog("E:/monitorzd/monitor_zd.log");
        dm.InitHCSdk();
        dm.InitDHSdk();
        ZD(dm,zdvalue,path);
//        GetLocalMacs(dm,zdvalue,path);
//	    	GETNVRPICIMG(dm,"H:/GT/monitorzd/");
//        NVRGETIP(dm);
//	    	ZD(dm,zdvalue,path);
        //结束日期
        Long endTime = System.currentTimeMillis();
        System.out.println("用时:" + sdf.format(new Date(endTime - startTime)));
    }
    //手动开启关闭录像
    public static void testRecodeStartAndEnd(final MonitorZD dm){
        int ret = dm.RecodeStartAndEnd("192.168.60.140",8000,"admin", "12345",1,33,"end");
        new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    Thread.sleep(10000);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                int ret = dm.RecodeStartAndEnd("192.168.60.140",8000,"admin", "12345", 1,33,"end");
                System.out.println("end:"+ret);
            }
        }).start();
        System.out.println(ret);
    }


    public static void GetLocalMacs(MonitorZD dm,String zdvalue,String path){
        System.out.println(dm.GetLocalMac());
//	    	System.out.println(dm.GetLocalPath());
        System.out.println(dm.GetLocalIp());

    }

    public static void ZD(MonitorZD dm,String zdvalue,String path){
        //dm.sayHello();
        //int err=dm.Start("172.16.10.150", 7000, "admin", "12345", 1,1,zdvalue,path);
//        int err=dm.Start("192.168.60.150", 8000, "admin", "admin12345", 1,2,zdvalue,path);
//        int err=dm.Start("10.20.106.134", 8000, "admin", "a12345678",1,1,zdvalue,path);
        int err=dm.Start("10.20.10.153", 8000, "admin", "ADMIN12345",1,2,zdvalue,path);
//        int err=dm.Start("10.20.159.140", 37777, "admin", "admin123456", 2,2,zdvalue,path);
        if(0==err||"0".equals(err)){
            System.out.println("启动诊断成功");
        }else{
            System.out.println("---"+err);
        }
        String ZDValue="";
        ZDValue=dm.GetValue();
        boolean isvalue=true;
        while(isvalue){
            if(null==ZDValue||"".equals(ZDValue)){
                ZDValue=dm.GetValue();
            }else{
                isvalue=false;
                //dm.Stop(1);
            }
        }
        String[] value=ZDValue.split("\\|F-G\\|");
	         /*for(int i=0;i<value.length;i++){
	         	System.out.println("诊断结果:"+value[i]);
	         }*/
        System.out.println("图像冻结1:"+value[0]);
        System.out.println("图像过亮2:"+value[1]);
        System.out.println("图像过暗3:"+value[2]);
        System.out.println("图像对比度4:"+value[3]);
        System.out.println("图像遮挡5:"+value[4]);
        System.out.println("图像失色6:"+value[5]);
        System.out.println("图像偏色7:"+value[6]);
        System.out.println("信号丢失8:"+value[7]);
        System.out.println("视频剧变9:"+value[8]);
        System.out.println("清晰度10:"+value[9]);
        System.out.println("噪点检测11:"+value[10]);
        System.out.println("场景变更12:"+value[11]);
        System.out.println("视频抖动13:"+value[12]);
        System.out.println("条纹干扰14:"+value[13]);
        System.out.println("云台失控15:"+value[14]);
        System.out.println("截图路径16:"+value[15]);
    }

    //获取NVR上IPC信息
    public static void NVRGETIP(MonitorZD dm){
        //String IPC=dm.NVRGETIP("172.16.10.160", 7000, "admin", "12345", 1);
        String IPC=dm.NVRGETIP("192.168.60.140", 8000, "admin", "12345", 1);
        //String IPC=dm.NVRGETIP("192.168.1.1", 8000, "admin", "12345", 1);
        String[] value=IPC.split("IPC");
        for(int i=0;i<value.length;i++){
            String[] MYIPC=value[i].split("\\|F-G\\|");
            if("0.0.0.0"==MYIPC[0]||"0.0.0.0".equals(MYIPC[0])){
                System.out.println("1");
            }else{
                System.out.println("设备IP:"+MYIPC[0]+";通道号:"+MYIPC[1]);
            }
        }
    }

    //通过DVR/nvr，获取通道号启用状态
    public static void GETDVRTDH(MonitorZD dm){
        String IPC=dm.GETDVRTDH("192.168.50.227", 8000, "admin", "ycc12345", 1);
        String[] a={"2"};//根据NVRID，查询已经存在表的通道号
        String[] TDH=IPC.split(",");
        for(int i=0;i<TDH.length;i++){
            if(!useList(a,TDH[i])&&(TDH[i].equals("1")||TDH[i]=="1")){
                System.out.println("通道："+(i+1)+"启用,随机生成名称：摄像机"+(i+1));
            }
        }
    }

    public static boolean useList(String[] arr, String targetValue) {
        return Arrays.asList(arr).contains(targetValue);
    }

    //获取单个设备信息
    public static void GETIPC(MonitorZD dm){
        //String IPC=dm.GETIPC("172.16.10.150", 7000, "admin", "12345", 1);
        //String IPC=dm.GETIPC("10.103.241.191", 8000, "admin", "632911632", 1);
        //String IPC=dm.GETIPC("10.103.251.12", 37777, "admin", "admin", 2);
        //String IPC=dm.GETIPC("192.168.50.150", 7000, "admin", "12345", 1);
        String IPC=dm.GETIPC("192.168.60.140", 87000, "admin", "12345", 2);
        System.out.println(IPC);
        //String[] value=IPC.split("\\|FG\\|");
        //System.out.println("设备型号:"+value[0]+";设备序列号"+value[1]);
    }

    public static void GETDVRJPG(MonitorZD dm,String path){
        String IPC=dm.GETDVRJPG("192.168.60.140", 8000, "admin", "12345", 1,33,path);
        System.out.println("抓图路径:"+IPC);
    }
    //获取球机坐标
    public static void GETPTZ(MonitorZD dm,String path){
        //String IPC=dm.GETPTZ("192.168.1.13", 7000, "admin", "12345", 1,path);
        //String IPC=dm.GETPTZ("172.16.10.150", 7000, "admin", "12345", 1,path);
        String IPC=dm.GETPTZ("172.16.10.190", 7000, "admin", "admin", 2,path);
        String[] value=IPC.split("\\|FG\\|");
        System.out.println("图片路径:"+value[0]+";P坐标:"+value[1]+";T坐标:"+value[2]+";Z坐标:"+value[3]);
    }


    public static void GETNVRPICIMG(MonitorZD dm,String path){
        //nvrIp,nvr端口，nvr账号，nvr密码，nvr类型（1海康，2大华），通道号（新版海康nvr是33开始，大华nvr从1开始），录像时间，保存路径
        String IPC=dm.GETNVRPICIMG("192.168.60.140", 8000, "admin", "12345", 1,33,3,path);
        System.out.println(IPC);
    }
}
