package com.chinaitop.depot.monitor.util;

import java.io.BufferedInputStream;
import java.io.InputStream;
import java.util.Properties;

import org.smslib.IOutboundMessageNotification;
import org.smslib.OutboundMessage;
import org.smslib.Service;
import org.smslib.Message.MessageEncodings;
import org.smslib.modem.SerialModemGateway;

//短信猫
public class SendMessage {

    public class OutboundNotification implements IOutboundMessageNotification {
        public void process(String gatewayId, OutboundMessage msg) {
            System.out.println("Outbound handler called from Gateway: "
                    + gatewayId);
            System.out.println(msg);
        }
    }

    @SuppressWarnings("deprecation")
    public synchronized void sendSMS(String mobilePhones, String content) {
        Service srv;
        OutboundMessage msg;
        OutboundNotification outboundNotification = new OutboundNotification();
        srv = new Service();
        //获取配置文件信息
        String urlProfile = "/application.properties";
        Properties pt = readProperties(urlProfile);
        String com = pt.getProperty("sendMessage.com");
        String modem = pt.getProperty("sendMessage.modem");

        SerialModemGateway gateway = new SerialModemGateway(modem,
                com, 9600, "wavecom", ""); //设置端口与波特率
        gateway.setInbound(true);
        gateway.setOutbound(true);
        gateway.setSimPin("0000");
        gateway.setOutboundNotification(outboundNotification);
        srv.addGateway(gateway);
        System.out.println("初始化成功，准备开启服务");
        try {
            srv.startService();
            System.out.println("服务启动成功");
            String[] phones = mobilePhones.split(",");
            for (int i = 0; i < phones.length; i++) {
                msg = new OutboundMessage(phones[i], content);
                msg.setEncoding(MessageEncodings.ENCUCS2); // 中文
                srv.sendMessage(msg);
            }
            srv.stopService();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static Properties readProperties(String filePath) {
        Properties props = new Properties();
        try {
            InputStream in = new BufferedInputStream(SendMessage.class.getResourceAsStream(filePath));
            props.load(in);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return props;
    }
}