package com.chinaitop.depot.supervise.controller;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.chinaitop.depot.supervise.service.CcZyService;
import com.chinaitop.depot.utils.ParameterUtil;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;

/**
 * @auther mafy
 * @createtime 2017/11/11 0011
 * 仓储作业-仓储作业记录
 */
@RestController
@RequestMapping(value = "/ccZy")
@Api(description = "仓储作业-仓储作业记录")
public class CcZyController {

    @Resource
    private CcZyService ccZyService;

    @RequestMapping(value = "/list", produces = MediaType.APPLICATION_JSON_VALUE, method = RequestMethod.GET)
    @ApiOperation(value="仓储处作业记录", notes = "查询仓储处作业记录")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页码", paramType = "query"),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", paramType = "query"),
            @ApiImplicitParam(name = "houseId", value = "仓房ID", paramType = "query"),
            @ApiImplicitParam(name = "startDate", value = "作业开始时间", paramType = "query"),
            @ApiImplicitParam(name = "endDate", value = "作业结束时间", paramType = "query"),
            @ApiImplicitParam(name = "orgId", value = "组织机构ID", paramType = "query")
    })
    public PageInfo<Map<String,Object>> getCcZyList(Integer pageNum, Integer pageSize,Integer houseId,String startDate,String endDate, Integer orgId){

        Map<String,Object> map = new HashMap<>();

        if(ParameterUtil.isnotnull(houseId)){
            map.put("houseId",houseId);
        }
        if(ParameterUtil.isnotnull(startDate)){
            map.put("startTime",startDate);
        }
        if(ParameterUtil.isnotnull(endDate)){
            map.put("endTime",endDate);
        }
        if(ParameterUtil.isnotnull(orgId)){
            map.put("orgId",orgId);
        }
        PageHelper.startPage(pageNum, pageSize);
        List<Map<String,Object>> list = ccZyService.getCcZyList(map);
        PageInfo<Map<String,Object>> pageInfo = new PageInfo<Map<String,Object>>(list);
        //处理驼峰命名大写问题
        List<Map<String, Object>> page_list = ParameterUtil.slashCapitals(pageInfo.getList());
        pageInfo.setList(page_list);
        return pageInfo;
    }

}
