package com.chinaitop.depot.supervise.service;

import com.chinaitop.depot.supervise.mapper.model.DepotStyle;
import com.chinaitop.depot.supervise.mapper.model.DepotStyleExample;

import java.util.List;
import java.util.Map;

/**
 * @auther mafy
 * @createtime 2017/10/28 0028
 */

public interface depotStyleService {
    /**
     * 监控的视频数据
     * @return
     */
    List<Map<String,Object>> getCameraPoint(Map<String, Object> map);

    /**
     * 粮情监测
     * @return
     */
    List<Map<String,Object>> getGrainsituation(Map<String, Object> map);

    /**
     * 获取仓储作业
     * @param map
     * @return
     */
    List<Map<String,Object>> selectWorkingForHouse(Map<String, Object> map);

    /**
     * 获取储粮信息
     * @param map
     * @return
     */
    List<Map<String,Object>> selectLQForHouse(Map<String, Object> map);

    /**
     * 获取正在进行通风的仓房
     * @param map
     * @return
     */
    List<Map<String,Object>> selectCLTask(Map<String, Object> map);

    /**
     * 获取正在进行熏蒸的仓房
     * @param map
     * @return
     */
    List<Map<String,Object>> selectCLXZ(Map<String, Object> map);

    /**
     * 获取正在进行入库的仓房
     * @param map
     * @return
     */
    List<Map<String,Object>> selectRK(Map<String, Object> map);

    /**
     * 获取正在进行出库的仓房
     * @param map
     * @return
     */
    List<Map<String,Object>> selectCK(Map<String, Object> map);

    /**
     * 添加点图数据
     * @return
     */
    void addPoint(DepotStyle depotStyle);

    /**
     * 删除点图数据
     * @return
     */
    void deletePoint(DepotStyle style);

    /**
     * 查询点图数据
     * @return
     */
    List<DepotStyle> selectPoint(DepotStyleExample example);

    /**
     * 仓房状态
     * @return
     */
    List<Map<String,Object>> getHouseStatePointChart(Map<String, Object> map);

	void deleteSxtPoint(DepotStyle depotStyle);

	void addSxtPoint(DepotStyle depotStyle);
}
