package com.chinaitop.depot.supervise.service.impl;

import com.chinaitop.depot.supervise.mapper.DepotStyleMapper;
import com.chinaitop.depot.supervise.mapper.model.DepotStyle;
import com.chinaitop.depot.supervise.mapper.model.DepotStyleExample;
import com.chinaitop.depot.supervise.service.depotStyleService;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.stereotype.Service;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.web.client.RestTemplate;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

@Service
public class depotStyleServiceImpl implements depotStyleService {

    @Resource
    private DepotStyleMapper depotStyleMapper;
    
    @Resource
    private RestTemplate restTemplate;
    
    @Value("${jsgjjsjUrl}")
    private String jsgjjsjUrl;


    @Override
    public List<Map<String,Object>> getCameraPoint(Map<String,Object> map) {
        return depotStyleMapper.selectByCameraPoint(map);
    }

    @Override
    public List<Map<String,Object>> getGrainsituation(Map<String,Object> map) {
        return depotStyleMapper.selectByGrainSituaiton(map);
    }

    /**
     * 获取仓储作业
     * @param map
     * @return
     */
    @Override
    public List<Map<String,Object>> selectWorkingForHouse(Map<String, Object> map) {
        return depotStyleMapper.selectWorkingForHouse(map);
    }
    /**
     * 获取储粮信息
     * @param map
     * @return
     */
    @Override
    public List<Map<String,Object>> selectLQForHouse(Map<String, Object> map) {
        return depotStyleMapper.selectLQForHouse(map);
    }


    /**
     * 获取正在进行通风的仓房
     *
     * @param map
     * @return
     */
    @Override
    public List<Map<String,Object>> selectCLTask(Map<String, Object> map) {
        return depotStyleMapper.selectCLTask(map);
    }

    /**
     * 获取正在进行熏蒸的仓房
     *
     * @param map
     * @return
     */
    @Override
    public List<Map<String,Object>> selectCLXZ(Map<String, Object> map) {
        return depotStyleMapper.selectCLXZ(map);
    }

    /**
     * 获取正在进行入库的仓房
     *
     * @param map
     * @return
     */
    @Override
    public List<Map<String,Object>> selectRK(Map<String, Object> map) {
        return depotStyleMapper.selectRK(map);
    }

    /**
     * 获取正在进行出库的仓房
     *
     * @param map
     * @return
     */
    @Override
    public List<Map<String,Object>> selectCK(Map<String, Object> map) {
        return depotStyleMapper.selectCK(map);
    }

    @Override
    public void addPoint(DepotStyle depotStyle) {
        depotStyleMapper.insert(depotStyle);
        this.gjjjk(depotStyle.getId(), depotStyle.getOrgId()+"", "i");
    }

    @Override
    public void deletePoint(DepotStyle style) {
        DepotStyleExample example = new DepotStyleExample();
        DepotStyleExample.Criteria criteria= example.createCriteria();
        criteria.andTypeEqualTo(style.getType());
        criteria.andIndexidEqualTo(style.getIndexid());
        depotStyleMapper.deleteByExample(example);
        this.gjjjk(style.getId(), style.getOrgId()+"", "d");
    }

    @Override
    public List<DepotStyle> selectPoint(DepotStyleExample example) {
        return depotStyleMapper.selectByExampleWithBLOBs(example);
    }

    @Override
    public List<Map<String,Object>> getHouseStatePointChart(Map<String,Object> map) {
        return depotStyleMapper.selectHouseState(map);
    }
    
    
    /**
   	 * 国家局数据
   	 */
       public void gjjjk(Integer id, String orgId,String czbz) {
           
    	   
    	String tableName = "ODS_UP_KQTCFDWBZSJXXJK";
   		/**
            * restTemplate调用
            */
           //String url = "http://localhost:9022/recPublish/sendMessage";//
           //发送post请求，并打印结果，以String类型接收响应结果JSON字符串
   		
        MultiValueMap<String, Object> sendMap = new LinkedMultiValueMap<>();
   		sendMap.add("tableName", tableName);
   		sendMap.add("czbz", czbz);
   		sendMap.add("ywId", id);
   		sendMap.add("orgId", orgId);

        restTemplate.postForObject(jsgjjsjUrl, sendMap, String.class);
           
       }


	@Override
	public void deleteSxtPoint(DepotStyle depotStyle) {
		// TODO Auto-generated method stub
		DepotStyleExample example = new DepotStyleExample();
        DepotStyleExample.Criteria criteria= example.createCriteria();
        criteria.andTypeEqualTo(depotStyle.getType());
        criteria.andIndexidEqualTo(depotStyle.getIndexid());
        depotStyleMapper.deleteByExample(example);
        this.sxtgjjjk(depotStyle.getId(), depotStyle.getOrgId()+"", "d");
	}


	@Override
	public void addSxtPoint(DepotStyle depotStyle) {
		// TODO Auto-generated method stub
		this.sxtgjjjk(depotStyle.getId(), depotStyle.getOrgId()+"", "i");
	}
	
	
	 /**
   	 * 摄像头国家局数据
   	 */
       public void sxtgjjjk(Integer id, String orgId,String czbz) {
    	   
    	   String tableName = "ODS_UP_KQTSPJKSBDWBZSJXXJK";
      		/**
               * restTemplate调用
               */
              //String url = "http://localhost:9022/recPublish/sendMessage";//
              //发送post请求，并打印结果，以String类型接收响应结果JSON字符串
      		
           MultiValueMap<String, Object> sendMap = new LinkedMultiValueMap<>();
      		sendMap.add("tableName", tableName);
      		sendMap.add("czbz", czbz);
      		sendMap.add("ywId", id);
      		sendMap.add("orgId", orgId);

           restTemplate.postForObject(jsgjjsjUrl, sendMap, String.class);
           
       }
       
}
